/*Winmain File */

//Sets up window with OpenGL support//

#pragma comment( lib, "opengl32.lib" )						
#pragma comment( lib, "glu32.lib" )						
#pragma comment( lib, "winmm.lib" )

//defines
#define WIN32_LEAN_AND_MEAN

//includes.
#include <windows.h> //windows
#include <gl/gl.h> //opengl include!!
#include <gl/glu.h> //GL Untilities.
#include <gl/glaux.h> //GL auxiliary func's.
#include <math.h> //for sin/cos
#include <stdio.h> //file stuff.
#include <stdlib.h> //memory functions
#include <mmsystem.h>

//function declarations..
void InitGl(void);
void RenderScene(void);
BOOL DI_Create(HINSTANCE g_H, HWND hWnd);

//varible declarationS.
bool fullscreen = false;//controls fullscreen yes/no.
HDC g_hdc; //global handle to device context.
HWND g_hWnd;


float g_FrameInterval = 0.0f;

float GetFrameInterval(void)
{
	return g_FrameInterval;
}


void CalculateFrameRate()
{
	//thanks to GameTutorials.com
	static float framesPerSecond    = 0.0f;		// This will store our fps
    static float lastTime			= 0.0f;		// This will hold the time from the last frame
	static char strFrameRate[50] = {0};			// We will store the string here for the window title



	static float frameTime = 0.0f;				// This stores the last frame's time


    float currentTime = timeGetTime() * 0.001f;				

 	g_FrameInterval = currentTime - frameTime;
	frameTime = currentTime;



	// Increase the frame counter
    ++framesPerSecond;

	// Now we want to subtract the current time by the last time that was stored
	// to see if the time elapsed has been over a second, which means we found our FPS.
    if( currentTime - lastTime > 1.0f )
    {
		// Here we set the lastTime to the currentTime
	    lastTime = currentTime;
		
		// Copy the frames per second into a string to display in the window title bar
		sprintf(strFrameRate, "Element's Isle %d fps", int(framesPerSecond));

		// Set the window title bar to our string
		SetWindowText(g_hWnd, strFrameRate);

		// Reset the frames per second
        framesPerSecond = 0;
    }
}



void Get_Pixel_Format(HDC hdc)
{ 
	//function to setup PIXELFORMATDESCRIPTOR structure for Opengl fun
	//pixelformat describes Z-buffer, color bits, surface details, etc.
	int pixelformatnumber; //pixel format index
	PIXELFORMATDESCRIPTOR	pfd;
	pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);//set the size
	pfd.nVersion = 1; //always 1, version ##.
	pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER; //set flags, draws to window, supports opengl, has a double buffer..
	pfd.iPixelType = PFD_TYPE_RGBA; 
	pfd.cColorBits = 32; //32 bit 
	pfd.cRedBits = 0; //no need for various other bits.
	pfd.cRedShift = 0;
	pfd.cBlueBits = 0;
	pfd.cBlueShift = 0;
	pfd.cGreenBits = 0;
	pfd.cGreenShift = 0;
	pfd.cAlphaBits = 0;
	pfd.cAlphaShift = 0;
	pfd.cAccumBits = 0; 
	pfd.cAccumRedBits = 0;
	pfd.cAccumGreenBits = 0;
	pfd.cAccumBlueBits = 0;
	pfd.cAccumAlphaBits = 0;
	pfd.cDepthBits = 16; //16 bit depth buffer. bwahah.
	pfd.cStencilBits = 0; //no need for stencil buffer yet.
	pfd.cAuxBuffers = 0;
	pfd.iLayerType = PFD_MAIN_PLANE; 
	pfd.bReserved = 0; 
	pfd.dwLayerMask = 0; 
	pfd.dwVisibleMask = 0; 
	pfd.dwDamageMask = 0; 

	//WOAH ..now that we got that thing filled out...lets just set the pixelformatnumber.
	pixelformatnumber = ChoosePixelFormat(hdc,&pfd);
	if (!SetPixelFormat(hdc,pixelformatnumber,&pfd))
	{
		MessageBox(NULL,"Set Pixel Format Error","Ahhhhhdarn it.",NULL);
	}


}//end Get_Pixel_Format.

/*Callback function */
LRESULT CALLBACK WndProc(HWND hwnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	static HDC		hdc;
	static HGLRC	hglrc;
	PAINTSTRUCT ps;
	switch (message)
	{
		case WM_CREATE:
			{
				hdc = GetDC(hwnd); //get DC
				g_hdc = hdc; //set the hdc to global.
				Get_Pixel_Format(hdc);
				hglrc = wglCreateContext(hdc); //Wiggle Function to get Rendering thingy.
				wglMakeCurrent(hdc,hglrc); //make it the current one attached to the HDC.
				//initilize opengl states and stuff for us.
				InitGl();
				
				return 0;
			
			}break;

		case WM_CLOSE:
			{
				wglMakeCurrent(hdc,NULL); //set the current rendering context to null so we can release it.
				wglDeleteContext(hglrc); //release it.
				ChangeDisplaySettings(NULL,0);
				PostQuitMessage(0); //quit hte proggie.

				return 0;
			}break;
		case WM_PAINT:
			{
				BeginPaint(hwnd,&ps);
				EndPaint(hwnd,&ps);
			}break;
		
		case WM_KEYDOWN:
			{//touch any key, program quits.
				
					//change the resolution back.
					/*DEVMODE dev;
					memset(&dev,0,sizeof(dev));

					dev.dmSize = sizeof(DEVMODE); //set the size..
					dev.dmPelsWidth = 1280; //setting width..
					dev.dmPelsHeight = 1024; //setting height.
					dev.dmBitsPerPel = 32; //32 bit...bwahah.
					dev.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL; //set the flags..
	
					if (ChangeDisplaySettings(&dev,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
						{
							MessageBox(NULL,"ahhh...crap...sorry. no fullscreen","doh",NULL); //boo.
							fullscreen = false; //switch back to normal mode.
						}
					
			PostQuitMessage(0);//post the quit message, get us out. */
			}break;

		case WM_SIZE:
			{ //window changed size.
				int height,width;//height,width..of course.
				height = HIWORD(lParam); //height is the HI bit of the lparam.
				width = LOWORD(lParam); //width is the LOW bit of the lParam.
				if (height == 0) //height can't equal 0..that wouldn't make much sense.
				{
					height = 1;
				}

				glViewport(0,0,width,height); //change viewport.
				glMatrixMode(GL_PROJECTION); //get ready to set projection matrix.
				glLoadIdentity(); //set it to the identity matrix.
				
				//change the perspective around, set clipping. etc.
				gluPerspective(45.0f,width/height,1.0f,10000.0f);

				glMatrixMode(GL_MODELVIEW); //changing modelview's matrix.
				glLoadIdentity(); //Set it ID matrix.

				return 0;

		}break;

		default:
			break;

	} //end switch

	//handle other messages I really don't care about.
	return DefWindowProc(hwnd,message,wParam,lParam);
	
}//ending winproc.


/*winmain */
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevinstance,LPSTR lpCmdLine,int nShowCmd)
{
	//nice question to start it off..

	if (MessageBox(NULL,"Do you want fullscreen mode?","Fullscreen?",MB_YESNO) == IDYES)
	{//if yes then go to fullscreen mode. bwahhahahaha.
		fullscreen = true;
	}

	//time to get serious..
	WNDCLASSEX	winclass;
	winclass.cbSize = sizeof(WNDCLASSEX); //self explanatory
	winclass.style = CS_VREDRAW | CS_HREDRAW; //set the window to redraw on any height/width changes.
	winclass.lpfnWndProc = WndProc; //Windows message handler thing.
	winclass.cbWndExtra = 0; //no extra stuff needed
	winclass.cbClsExtra = 0; //see above.
	winclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); //set background to white.
	winclass.hCursor = LoadCursor(NULL,IDC_ARROW); //normal arrow, prolly not neccecary.
	winclass.hIcon = NULL; //no icon for mE. HAHAHAAHAH.
	winclass.hInstance = hInstance; //Main instance of hte program.
	winclass.lpszClassName = "WindowClass"; //class name
	winclass.lpszMenuName = NULL; //no menu yet.
	winclass.hIconSm = NULL; //no small icon needed either.

	//regestering the class..
	if (!RegisterClassEx(&winclass))
	{
		MessageBox(NULL,"Couldnt Register Class","Ouch",NULL);
	}

	//if full screen mode then fill out a devmode structure to change the display.
	if (fullscreen)
	{

	//get data for fullscreenmode.
	DEVMODE dev;
	memset(&dev,0,sizeof(dev));
	EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&dev);

	dev.dmSize = sizeof(DEVMODE); //set the size..
	dev.dmPelsWidth = 1024; //setting width..
	dev.dmPelsHeight = 768; //setting height.
	dev.dmBitsPerPel = 32; //32 bit...bwahah.
	dev.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL; //set the flags..
	
	if (ChangeDisplaySettings(&dev,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
	{
		MessageBox(NULL,"ahhh...crap...sorry. no fullscreen","doh",NULL); //boo.
		fullscreen = false; //switch back to normal mode.
	}

	
	}
	//now to create the window off of the winclass there.
	HWND mainwindowhandle; //Holds our windows handle.
	
	if (fullscreen)
	{
	mainwindowhandle = CreateWindowEx(NULL,//no extended style
		"WindowClass",//class name. Must be same as in winclass.lpszClassName.
		"OpenGl Window",//window caption.
		WS_POPUP,//window styles, different than for normal window
		0,0,//x,y
		1024,768,//width, height.
		NULL,//parent winow handle,
		NULL,//menue handle
		hInstance,//hinstance
		NULL);//Extra Params.
	ShowCursor(false);
	}//end if
	
	else
	{
		//everything is normal...
	mainwindowhandle = CreateWindowEx(NULL,//no extended style
		"WindowClass",//class name. Must be same as in winclass.lpszClassName.
		"OpenGl Window",//window caption.
		WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_SYSMENU,//window styles
		200,200,//x,y
		400,400,//width, height.
		NULL,//parent winow handle,
		NULL,//menue handle
		hInstance,//hinstance
		NULL);//Extra Params.

	
	}//end else
	if (!mainwindowhandle)
	{
		MessageBox(NULL,"Couldnt make main window","Wow that sucks",NULL);
		return 0;
	}

	//show the window.
	ShowWindow(mainwindowhandle,TRUE);
	UpdateWindow(mainwindowhandle); //update the window for the heck of it.
	
	DI_Create(hInstance,mainwindowhandle);
	g_hWnd = mainwindowhandle;
	//entering message loop now.
	bool quitmessage = false; //used for loop until WM_QUIT message is recieved.
	MSG	 message; //message..umm..yeah.
	while (!quitmessage) //ener loop, while quitmessage = false go threw it.
	{
		//do we have a message?
		PeekMessage(&message,mainwindowhandle,NULL,NULL,PM_REMOVE);
		//make sure message isn't a quit message.
		if (message.message == WM_QUIT)
		{
			quitmessage = true;
		}
		else
		{
			//rendering function goes here.
			CalculateFrameRate();
			RenderScene();
			SwapBuffers(g_hdc); //flip the surfaces.
			//Send off message to whereever messages go.
			TranslateMessage(&message);
			DispatchMessage(&message);
		
		}


	}

	return message.wParam; //send back the wParam
}