/* sound effects, etc with DirectX8 Audio. */
/* haha..oh boy...wrote this as I went along again :P  0 */
/*should've wrote a generic "playsound" function but wasn't thinking right */

#define INITGUID

#include <windows.h>
#include <dmusicc.h>
#include <dmusici.h>
#include <cguid.h>                

IDirectMusicPerformance8* musicperformance = NULL;
IDirectMusicLoader8* loader = NULL;
IDirectMusicSegment8* rainsegment = NULL;
IDirectMusicSegment8* windsegment = NULL;
IDirectMusicSegment8* ambientsegment = NULL;
IDirectMusicAudioPath8* windpath = NULL;
IDirectMusicAudioPath8* rainpath = NULL;
IDirectMusicAudioPath8* ambientpath = NULL;

IDirectSound3DBuffer *windbuffer = NULL;
IDirectSound3DListener *listener = NULL;  



DS3DBUFFER soundbufferparams;
DS3DLISTENER listenerparams;

char filebuffer[MAX_PATH];
WCHAR filebufferreadable[MAX_PATH];


typedef struct _fireworksound
{

	//these two hold files 
	IDirectMusicSegment8* boomsegment;
	IDirectMusicSegment8* whistlesegment;

	//one path should work fine since both sounds will never play at same time
	IDirectMusicAudioPath8* fireworksaudiopath;
	
	//one soundbuffer should work for same reason as above..
	IDirectSound3DBuffer *fireworkssoundbuffer;
	
	//"ditto" as up there.
	IDirectSound3DListener *fireworkslistener;

	DS3DBUFFER fireworksbuffersoundparams;
	
	DS3DLISTENER fireworkslistenerparams;

	bool fired; 
}FIREWORKSOUND,*PTR_FIREWORKSOUND;


FIREWORKSOUND fireworksounds[5]; //5 total fireworks, five total sets of sound, each set containing a whistle and a pop.

void SetupFireworkSounds(void)
{
	int counter;
	WCHAR buffer[MAX_PATH];
	for (counter = 0; counter < 5; counter++)
	{
		fireworksounds[counter].fired = false;
		/*****First Load Whistle Sound for Whistle sounding******/
		MultiByteToWideChar(CP_ACP,0,"whistle.wav",-1,buffer,MAX_PATH);
		if (FAILED(loader->LoadObjectFromFile(CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,buffer,(void**)&fireworksounds[counter].whistlesegment)))
		{
			MessageBox(NULL,"cant load whistle.wav","error",NULL);
		}

		/********Now Load Popping Sound *******/
		MultiByteToWideChar(CP_ACP,0,"pop.wav",-1,buffer,MAX_PATH);
		if (FAILED(loader->LoadObjectFromFile(CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,buffer,(void**)&fireworksounds[counter].boomsegment)))
		{
			MessageBox(NULL,"cant load pop.wav","error",NULL);
		}


		//ok...both sounds are loaded...now too...create the fireworks general audio path.

		if (FAILED(musicperformance->CreateStandardAudioPath(DMUS_APATH_DYNAMIC_3D,64,TRUE,&fireworksounds[counter].fireworksaudiopath)))
		{
			MessageBox(NULL,"cant make fireworks sound audio path","error",NULL);
		}

	//NOTE TO SELF REMEMBER TO DOWNLOAD INSTRUMENT SOUNDS!!!

	//but first, get soundbuffer for the audio path..
	if (FAILED(fireworksounds[counter].fireworksaudiopath->GetObjectInPath(DMUS_PCHANNEL_ALL,DMUS_PATH_BUFFER,0,GUID_NULL,0,IID_IDirectSound3DBuffer,(void**)&fireworksounds[counter].fireworkssoundbuffer)))
	{
		MessageBox(NULL,"Cant make fireworks 3d sound buffer","error",NULL);
	}

	//fill in the soundbuffer's parameters..
	fireworksounds[counter].fireworksbuffersoundparams.dwSize = sizeof(DS3DBUFFER);
	fireworksounds[counter].fireworkssoundbuffer->GetAllParameters(&soundbufferparams);
	fireworksounds[counter].fireworksbuffersoundparams.dwMode = DS3DMODE_NORMAL;//DS3DMODE_HEADRELATIVE;
	fireworksounds[counter].fireworkssoundbuffer->SetAllParameters(&soundbufferparams,DS3D_IMMEDIATE);
	
	//now a listener for this specific firework..
	if (FAILED(fireworksounds[counter].fireworksaudiopath->GetObjectInPath(0,DMUS_PATH_PRIMARY_BUFFER,0,GUID_NULL,0,IID_IDirectSound3DListener,(void**)&fireworksounds[counter].fireworkslistener)))
	{
		MessageBox(NULL,"Cant Make Fireworks 3d listener","blah",NULL);
	}
	
	//oie...now set up listener parameters..
		//oie...now set up listener parameters..
	fireworksounds[counter].fireworkslistenerparams.dwSize = sizeof(DS3DLISTENER);
	fireworksounds[counter].fireworkslistener->GetAllParameters(&listenerparams);

	
	fireworksounds[counter].fireworkslistenerparams.vPosition.x = 0;
	fireworksounds[counter].fireworkslistenerparams.vPosition.y = 0;
	fireworksounds[counter].fireworkslistenerparams.vPosition.z = 0;
	
	fireworksounds[counter].fireworkslistenerparams.flDopplerFactor = 0.1f;
	fireworksounds[counter].fireworkslistenerparams.flRolloffFactor = 0.1f;
	fireworksounds[counter].fireworkslistener->SetAllParameters(&fireworksounds[counter].fireworkslistenerparams,DS3D_IMMEDIATE);

	fireworksounds[counter].fireworksbuffersoundparams.flMinDistance = 1.0f;
	fireworksounds[counter].fireworksbuffersoundparams.flMaxDistance = 2000.0f;

	fireworksounds[counter].fireworkssoundbuffer->SetAllParameters(&fireworksounds[counter].fireworksbuffersoundparams,DS3D_IMMEDIATE);
	fireworksounds[counter].fireworkssoundbuffer->SetPosition(0,0,0,DS3D_IMMEDIATE);

	fireworksounds[counter].boomsegment->Download(musicperformance);
	fireworksounds[counter].whistlesegment->Download(musicperformance);

	}//end loop.

}//end function.


void InitDXAUDIO(void)
{
	
	//start up DirectAudio
	CoInitialize(NULL);

	if (FAILED(CoCreateInstance(CLSID_DirectMusicPerformance,NULL,CLSCTX_INPROC,IID_IDirectMusicPerformance8,(void**)&musicperformance)))
	{
		MessageBox(NULL,"CoCreateInstance(CLSID_DirectMusicPerformance) failed","Error",NULL);
	}

	
	if (FAILED(musicperformance->InitAudio(NULL,NULL,NULL,DMUS_APATH_SHARED_STEREOPLUSREVERB,64,DMUS_AUDIOF_ALL,NULL)))
	{
		MessageBox(NULL,"InitAudio() failed","Error",NULL);
	}


	if (FAILED(CoCreateInstance(CLSID_DirectMusicLoader,NULL,CLSCTX_INPROC,IID_IDirectMusicLoader8,(void**)&loader)))
	{
		MessageBox(NULL,"CoCreateInstance(CLSID_DirectMusicLoader failed","error",NULL);
	}

	
	GetCurrentDirectory(MAX_PATH,filebuffer);

	MultiByteToWideChar(CP_ACP,0,filebuffer,-1,filebufferreadable,MAX_PATH);
	
	loader->SetSearchDirectory(GUID_DirectMusicAllTypes,filebufferreadable,FALSE);



	//load files I need
	
	WCHAR buffer[MAX_PATH];
	
	MultiByteToWideChar(CP_ACP,0,"rain.wav",-1,buffer,MAX_PATH);

	if (FAILED(loader->LoadObjectFromFile(CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,buffer,(void**)&rainsegment)))
	{
		MessageBox(NULL,"LoadObjectFromFile() failed","Error",NULL);
	} 

	if (FAILED(musicperformance->CreateStandardAudioPath(DMUS_APATH_DYNAMIC_MONO,64,TRUE,&rainpath)))
	{
		MessageBox(NULL,"No audiopath for rain","error",NULL);
	}
	

	


	//load instruments.
	rainsegment->Download(musicperformance); 

	
	MultiByteToWideChar(CP_ACP,0,"ambient.wav",-1,buffer,MAX_PATH);

	if (FAILED(loader->LoadObjectFromFile(CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,buffer,(void**)&ambientsegment)))
	{
		MessageBox(NULL,"ambient.wav","Error",NULL);
	}

	
	if (FAILED(musicperformance->CreateStandardAudioPath(DMUS_APATH_DYNAMIC_MONO,64,TRUE,&ambientpath)))
	{
		MessageBox(NULL,"no audio path making went well today","error",NULL);
	}

	ambientsegment->Download(musicperformance);
	ambientpath->SetVolume(-1000,0);
	ambientsegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
	musicperformance->PlaySegmentEx(ambientsegment,NULL,NULL,DMUS_SEGF_DEFAULT,0,NULL,NULL,ambientpath);
	//Wind Specific Code (3d buffer, etc.
	MultiByteToWideChar(CP_ACP,0,"wind.wav",-1,buffer,MAX_PATH);
	if (FAILED(loader->LoadObjectFromFile(CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,buffer,(void**)&windsegment)))
	{
		MessageBox(NULL,"Wind.wav missing","error",NULL);
	}

	if (FAILED(musicperformance->CreateStandardAudioPath(DMUS_APATH_DYNAMIC_3D,64,TRUE,&windpath)))
	{
		MessageBox(NULL,"Cant make Audio Path","error",NULL);
	}  
	
	//3d sound buffer..

	if (FAILED(windpath->GetObjectInPath(DMUS_PCHANNEL_ALL,DMUS_PATH_BUFFER,0,GUID_NULL,0,IID_IDirectSound3DBuffer,(void**)&windbuffer)))
	{
		MessageBox(NULL,"Cant make 3d sound buffer","error",NULL);
	}

	soundbufferparams.dwSize = sizeof(DS3DBUFFER);
	windbuffer->GetAllParameters(&soundbufferparams);
	soundbufferparams.dwMode = DS3DMODE_NORMAL;//DS3DMODE_HEADRELATIVE;
	windbuffer->SetAllParameters(&soundbufferparams,DS3D_IMMEDIATE);

	
	//set up listener.
	if (FAILED(windpath->GetObjectInPath(0,DMUS_PATH_PRIMARY_BUFFER,0,GUID_NULL,0,IID_IDirectSound3DListener,(void**)&listener)))
	{
		MessageBox(NULL,"Cant Make DS listener","blah",NULL);
	}

	listenerparams.dwSize = sizeof(DS3DLISTENER);
	listener->GetAllParameters(&listenerparams);

	
	listenerparams.vPosition.x = 0;
	listenerparams.vPosition.y = 0;
	listenerparams.vPosition.z = 0;
	
	listenerparams.flDopplerFactor = 0.0f;
	listenerparams.flRolloffFactor = 0.1f;
	listener->SetAllParameters(&listenerparams,DS3D_IMMEDIATE);

	soundbufferparams.flMinDistance = 1.0f;
	soundbufferparams.flMaxDistance = 2000.0f;

	windbuffer->SetAllParameters(&soundbufferparams,DS3D_IMMEDIATE);
	windbuffer->SetPosition(0,0,0,DS3D_IMMEDIATE);
	
	
	windsegment->Download(musicperformance);

	SetupFireworkSounds();
	
	
}

void SetFireworkPosition(int number,float x,float y,float z)
{
	fireworksounds[number].fireworkssoundbuffer->SetPosition(x,y,-z,DS3D_IMMEDIATE);
}

void PlayFireworkBoom(int x)
{

	if (musicperformance->IsPlaying(fireworksounds[x].boomsegment,NULL) !=S_OK)
	{
		//play boom.
		if (fireworksounds[x].fired == false)
		{
		musicperformance->PlaySegmentEx(fireworksounds[x].boomsegment,NULL,NULL,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY,0,NULL,NULL,fireworksounds[x].fireworksaudiopath);
		fireworksounds[x].fired = true;
		}
	}
	

}

void StopFireworkBoom(int x)
{
	musicperformance->StopEx(fireworksounds[x].boomsegment,0,0);
	fireworksounds[x].fired = false;
}


void PlayFireworkWhistle(int x)
{
	if (musicperformance->IsPlaying(fireworksounds[x].whistlesegment,NULL) != S_OK)
	{
		//segment isn't playing..
		//musicperformance->PlaySegmentEx(fireworksounds[x].whistlesegment,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY,0,NULL,NULL,fireworksounds[x].fireworksaudiopath);
		musicperformance->PlaySegmentEx(fireworksounds[x].whistlesegment,NULL,NULL,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY,0,NULL,NULL,fireworksounds[x].fireworksaudiopath);
	}

}

void StopFireworkWhistle(int x)
{
	musicperformance->StopEx(fireworksounds[x].whistlesegment,0,0);
}


void PlayRainSound(void)
{ 
	if (musicperformance->IsPlaying(rainsegment,NULL) != S_OK)
	{
	rainsegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
	rainpath->SetVolume(-2000,0);

	
	//if (musicperformance->IsPlaying(windsegment,NULL) == S_OK)

	//{
		musicperformance->PlaySegmentEx(rainsegment,NULL,NULL,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY,0,NULL,NULL,rainpath);//both last NULLs were rainpath
	//}
	//else
	//{ 
		//musicperformance->PlaySegmentEx(rainsegment,NULL,NULL,DMUS_SEGF_DEFAULT,0,NULL,NULL,rainpath);
	//}

	}
}

void StopRainSound(void)
{
	if (musicperformance->IsPlaying(rainsegment,NULL) == S_OK)
	{
		musicperformance->StopEx(rainsegment,0,0);
	}

}


void PlayWindSound(void)
{
	if (musicperformance->IsPlaying(windsegment,NULL) != S_OK)
	{
		windpath->SetVolume(0,0);
		windsegment->SetRepeats(DMUS_SEG_REPEAT_INFINITE);
		

		
			musicperformance->PlaySegmentEx(windsegment,NULL,NULL,DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY,0,NULL,NULL,windpath); //was windpath
		
		
	}

}

void SetWindSoundPosition(float x, float y, float z)
{//tornado moves, so the sound coming from it should move also.
	windbuffer->SetPosition(x,y,-z,DS3D_IMMEDIATE);
}

void SetListenerPosition(float x, float y, float z, float lx, float ly, float lz)
{
	listenerparams.dwSize = sizeof(DS3DLISTENER);
	listener->GetAllParameters(&listenerparams);
	listenerparams.flDopplerFactor = 0.0f;
	listenerparams.flRolloffFactor = 0.01f;

	listenerparams.vPosition.x = x;
	listenerparams.vPosition.y = y;
	listenerparams.vPosition.z = -z;
	listenerparams.vOrientFront.x = lx;
	listenerparams.vOrientFront.y = ly;
	listenerparams.vOrientFront.z = -lz;
	listener->SetAllParameters(&listenerparams,DS3D_IMMEDIATE); 

	/*soundbufferparams.flMinDistance = 1.0f;
	soundbufferparams.flMaxDistance = 1000.0f;

	windbuffer->SetAllParameters(&soundbufferparams,DS3D_IMMEDIATE); */
}

void StopWindSound(void)
{
	if (musicperformance->IsPlaying(windsegment,NULL) == S_OK)
	{
		musicperformance->StopEx(windsegment,0,0);
	}

}


void ShutdownAudio(void)
{
	//release all goofy sounds..
	windbuffer->Release();
	listener->Release();
	ambientpath->Release();
	rainpath->Release();
	windpath->Release();
	ambientsegment->Release();
	windsegment->Release();
	rainsegment->Release();
	loader->Release();
	musicperformance->Release();

}

