/*File for loading,controlling,and destroying DirectInput.  also contains mouselook things.
  Fun for the whole family. Put DI_Create() in our WinMain() */


/**************Defines***************/
#define INITGUID //for directinpug GUID's
#pragma comment( lib, "opengl32.lib" )						
#pragma comment( lib, "glu32.lib" )	
#pragma comment (lib, "glaux.lib" )					
#pragma comment( lib, "winmm.lib" )
#pragma comment( lib,  "dinput.lib" )


/**************includes**************/

#include <dinput.h>
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include <math.h>


/**************typedefs**************/
//main camera structure
typedef struct _CAMERA
{
	//our camera structure...holds its lookat points and all that kinda stuff.
	float px,py,pz; //cameras position x,y,z.
	float lx,ly,lz; //cameras lookat x,y,z.
	float angleturn,angleup,angle_step_left,angle_step_right; //amount of angle sideto side and up/down.
	float r,k; //contants for rotation and etc.
}camera,*ptr_camera;


float GetHeight(float x, float z);
void SetRain(bool x);
void SetFireworks(bool x);
void SetWind(bool x);
void SetupFireworks(void);
float GetFrameInterval(void);
void SetListenerPosition(float x, float y, float z, float lx, float ly, float lz);
void ShutdownAudio(void);
void ShutdownDInput(void);
/**************varible defines*******/

//input things.
LPDIRECTINPUT	lpdi = NULL;
LPDIRECTINPUTDEVICE	keyboard = NULL;
char	keystate[256]; //to hold 
LPDIRECTINPUTDEVICE mouse = NULL;
int winwidth,winheight;
camera Camera; //main camera.


/**************Function's ************/
float GetAngleUp(void)
{
	return Camera.angleup;
}


float GetAngleturn(void)
{
	return Camera.angleturn;
}


//Handles our input.
void CheckInput(void)
{
	//check for imput of some sort. NOTE TO SELF MOVE TO SELF CONTAINING FUNCTION THANKS.
	DIMOUSESTATE	mousestate;
	
	if (FAILED(keyboard->GetDeviceState(sizeof(keystate),(LPVOID)keystate)))
	{
		MessageBox(NULL,"Cant get keyboard device state","haha",NULL);
	
	}
	
	if (FAILED(mouse->GetDeviceState(sizeof(DIMOUSESTATE),(LPVOID)&mousestate)))
	{
		MessageBox(NULL,"Cant get mouse d evice state","ha",NULL);
		
	}

	//test movement keys.
	if (keystate[DIK_Q] & 0x80)
	{//did they hit space?
		ShutdownDInput();
		ShutdownAudio();
		ShowCursor(true);
		ChangeDisplaySettings(NULL,0);
		PostQuitMessage(0);
		
	}

	//mouselook things..
	if (mousestate.lX != 0)
	{
		//eh oh they moved the mouse sideways.
			
			Camera.angleturn = Camera.angleturn - mousestate.lX;
		


	} //end xaxis mouselook text.

	if (mousestate.lY !=0)
	{
		//moving on the yaxix..

			
			Camera.angleup = Camera.angleup - mousestate.lY;

		
	


	} //end mouselook yxaxix test.

	if (keystate[DIK_O] & 0x80)
	{
		
	}


	if (keystate[DIK_U] & 0x80)
	{
		SetWind(true);
	}
	if (keystate[DIK_J] & 0x80)
	{
		SetWind(false);
	}


	if (keystate[DIK_T] & 0x80)
	{
		SetRain(true);
	}
	if (keystate[DIK_G] & 0x80)
	{
		SetRain(false);
	}


	if (keystate[DIK_Y] & 0x80)
	{
		SetFireworks(true);
		SetupFireworks();
	}

	if (keystate[DIK_H] & 0x80)
	{
		SetFireworks(false);
	}


	if (keystate[DIK_E] & 0x80)
	{
		//move back.	//this was 4.0f.
		Camera.pz = Camera.pz - (150.0f * GetFrameInterval() ) * cosf(Camera.angleturn * Camera.k);
		Camera.px = Camera.px - (150.0f * GetFrameInterval() )  * sinf(Camera.angleturn * Camera.k);

	}

	if (keystate[DIK_D] & 0x80)
	{
		//move ahead.
		Camera.px = Camera.px + (150.0f * GetFrameInterval() ) * sinf(Camera.angleturn * Camera.k);
		Camera.pz = Camera.pz + (150.0f * GetFrameInterval() ) * cosf(Camera.angleturn * Camera.k);
	}

	if (keystate[DIK_S] & 0x80)
	{
		//step side to the left.
		Camera.angle_step_left = Camera.angleturn - 90;
		if (Camera.angle_step_left < 0)
		{
			Camera.angle_step_left = Camera.angle_step_left + 360.0f;
		}
		if (Camera.angle_step_left > 360)
		{
			Camera.angle_step_left = Camera.angle_step_left - 360.0f;
		}

		//update coord's..
		Camera.px = Camera.px + (150.0f * GetFrameInterval() ) * sinf(Camera.angle_step_left * Camera.k);
		Camera.pz = Camera.pz + (150.0f * GetFrameInterval() ) * cosf(Camera.angle_step_left * Camera.k);


	} //end stepside left IF.

	if (keystate[DIK_F] & 0x80)
	{
		//stepsiding to the right. 

		Camera.angle_step_right = Camera.angleturn + 90;

		//make suer the cameras in a circles range..
		if (Camera.angle_step_right < 0)
		{
			Camera.angle_step_right = Camera.angle_step_right+ 360.0f;
		}

		if (Camera.angle_step_right > 360)
		{
			Camera.angle_step_right = Camera.angle_step_right - 360.0f;
		}

		Camera.px = Camera.px + (150.0f * GetFrameInterval() ) * sinf(Camera.angle_step_right * Camera.k);
		Camera.pz = Camera.pz + (150.0f * GetFrameInterval() ) * cosf(Camera.angle_step_right * Camera.k);


	} //end stepside left code.


	//update the lookat points of hte camera based on angles we took from above..
	//make sure angleturn is in range..
	if (Camera.angleturn > 360)
	{
		Camera.angleturn = Camera.angleturn - 360;
	}
	if (Camera.angleturn < 360)
	{
		Camera.angleturn = Camera.angleturn + 360;
	}

	if (Camera.angleup > 90)
	{
		Camera.angleup = 90;
	}

	if (Camera.angleup <-90)
	{
		Camera.angleup = -90;
	}
		if (Camera.px >  4800)
	{
		Camera.px = 4800;
	}
	if (Camera.px < 100)
	{
		Camera.px = 100;
	}

	if (Camera.pz < -4800)
	{
		Camera.pz = -4800;
	}
	if (Camera.pz > -100)
	{
		Camera.pz = -100;
	}
	//calculate the look at points based on the angle 's and the camera position itself.
	Camera.py = GetHeight(Camera.px,Camera.pz) + 30 + 20;
	Camera.lx = Camera.px - Camera.r * sinf(Camera.angleturn * Camera.k);
	Camera.ly = Camera.py + Camera.r * sinf(Camera.angleup * Camera.k);
	Camera.lz = Camera.pz- Camera.r * cosf(Camera.angleturn * Camera.k);
	//update the camera for uS!




	
	gluLookAt(Camera.px,Camera.py,Camera.pz,Camera.lx,Camera.ly,Camera.lz,0.0f,1.0f,0.0f);
	SetListenerPosition(Camera.px,Camera.py,Camera.pz, Camera.lx, Camera.ly, Camera.lz);
}


BOOL DI_Create(HINSTANCE g_H, HWND hWnd)
{
	/*sets up Direct Input for Keyboard/Mouse use*/
	
	if (FAILED(DirectInputCreate(g_H,DIRECTINPUT_VERSION,&lpdi,NULL)))
	{
		MessageBox(NULL,"cant create DI thingy","haha",NULL);
		return 0;
	}
	

	if (FAILED(lpdi->CreateDevice(GUID_SysKeyboard,&keyboard,NULL)))
	{
		MessageBox(NULL,"Cant create keyboard device!","hahaha",NULL);
		return 0;
	}

	if (FAILED(keyboard->SetCooperativeLevel(hWnd,DISCL_BACKGROUND | DISCL_NONEXCLUSIVE)))
	{
		MessageBox(NULL,"Yahoos...oh. the copperative level fails for keyboard","ha",NULL);
		return 0;
	}

	if (FAILED(keyboard->SetDataFormat(&c_dfDIKeyboard)))
	{
		MessageBox(NULL,"Cant setkeyboard data format","keyboard",NULL);
		return 0;
	}
	if (FAILED(keyboard->Acquire()))
	{
		MessageBox(NULL,"cant aquire keyboard","keyboard",NULL);
		return 0;
	}
	
	if (FAILED(lpdi->CreateDevice(GUID_SysMouse,&mouse,NULL)))
	{
		MessageBox(NULL,"Cant create mouse object","sigh",NULL);
		return 0;
	}

	if (FAILED(mouse->SetCooperativeLevel(hWnd,DISCL_BACKGROUND | DISCL_NONEXCLUSIVE)))
	{
		MessageBox(NULL,"cant set coop level for mouse","mouse",NULL);
		return 0;
	}

	if (FAILED(mouse->SetDataFormat(&c_dfDIMouse)))
	{
		MessageBox(NULL,"Cant set data format for mouse","doh",NULL);
		return 0;
	}

	if (FAILED(mouse->Acquire()))
	{
		MessageBox(NULL,"Couldnt aquire mouse","Whats its problem",NULL);
		return 0;
	}


   	//first , set the camera position to 0,0,0 and make it look down the negitive z axis.
	Camera.px = 0.0f;
	Camera.py = 0.0f;
	Camera.pz = 0.0f;
	Camera.lx = 0.0f;
	Camera.ly = 0.0f;
	Camera.lz = -100.0f;

	//controls for mouse look, ignore for now.
	Camera.angle_step_left = 0.0f;
	Camera.angle_step_right = 0.0f;
	Camera.angleturn = 0.0f;
	Camera.angleup = 0.0f;

	//camera constants.
	Camera.r = 100.0f;
	Camera.k = 0.017453292f; 
	
	//now set the camera to ..umm..the camera. 
	gluLookAt(Camera.px,Camera.py,Camera.pz,Camera.lx,Camera.ly,Camera.lz,0.0f,1.0f,0.0f);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);


return 1;

}


void ShutdownDInput(void)
{
	mouse->Release();
	keyboard->Release();
	lpdi->Release();
}




