/*Opengl File */


#pragma comment( lib, "opengl32.lib" )						
#pragma comment( lib, "glu32.lib" )						
#pragma comment( lib, "winmm.lib" )	



//includes
#include <windows.h> //windows
#include <gl/gl.h> //opengl include!!
#include <gl/glu.h> //GL Untilities.
#include <gl/glaux.h> //GL auxiliary func's.
#include <math.h> //for sin/cos
#include <stdio.h> //file stuff.
#include <stdlib.h> //memory functions

//declarations:


//texture details


//for changing of weather
float fogendpoint;
float incriment;
bool fogyesno;
float red,green,blue;
DWORD time;


//enables
bool rain;
bool fireworks;
bool wind;



//fucntion definitions

void CheckInput(void);
void InitTerrain(void);
void DrawTerrain(void);
void DrawWater(void);
void WaterSetup(void);
void DoRain(void);
void SetupRain(void);
//void SetUpParticles(float size);
//void DoParticles(void);
void SetupFireworks(void);
void DrawFireworks(void);
void DrawPlants(void);
void InitTGA(void);
void DoTwister(void);
void InitTwister(void);
void InitDXAUDIO(void);
void PlayRainSound(void);
void StopRainSound(void);
void StopWindSound(void);
void SetWind(bool x)
{
	
	wind = x;
}

void SetFireworks(bool x)
{
	fireworks = x;
}


void SetRain(bool x)
{
	rain = x;
}


void InitGl(void)
{
	//initialize states, lights, load textures, etc.
	glEnable(GL_DEPTH_TEST); //z-buffer enable.


	InitTerrain();
	WaterSetup();
	SetupRain();
	SetupFireworks();
	InitTGA();


	glClearColor(0.25f,0.25f,0.25f,1.0f);
	float fogcolor[] = {0.25f,0.25f,0.25f,1.0f};
	glEnable(GL_FOG);
	glFogi(GL_FOG_MODE,GL_LINEAR);
	glFogfv(GL_FOG_COLOR,fogcolor);
	glFogf(GL_FOG_DENSITY,0.35f);
	glHint(GL_FOG_HINT,GL_NICEST);
	glFogf(GL_FOG_START,0.0f);
	glFogf(GL_FOG_END,500.0f);

	fogendpoint = 500.0f;
	incriment = 175.0f;

	red = 0.25f;
	blue = 0.25f;
	green = 0.25f;
	time = GetTickCount();
	fogyesno = 1;

	rain = false;
	fireworks = false;
	wind = false;
	InitTwister();
	InitDXAUDIO();  //move this to winmain.cpp..
	//SetUpParticles(.5f);

}

void RenderScene(void)
{
	//function for rendering whole scene.
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //clear viewport and depth buffer.
	glLoadIdentity(); //reset modelview matrix. (still in that mode from WM_SIZE)


//	CheckInput();

	CheckInput();

	glTranslatef(0.0f,0.0f,-5.0f); //moving modelview back 5, then move it along a sinwave.
	 //add to the sinangle for going on the sinwave.
	
	//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); //wireframe.
	glShadeModel(GL_SMOOTH); //smooth shading.
	//glEnable(GL_DEPTH_TEST); //Z-Buffer baby.
	glPushMatrix();

	DrawTerrain();
	glPopMatrix();
	glPushMatrix();
	//glDisable(GL_FOG);
	DrawWater();
	glEnable(GL_FOG);
	glPopMatrix();
	
	
	if (rain == true)
	{
	glPushMatrix();
	DoRain();
	glPopMatrix();
	}

	
	//glTranslatef(0,200,-2000);
	glDisable(GL_FOG);
	if (fireworks == true)
	{

	DrawFireworks();
	}

	if (fogyesno == 1)
	{
	glEnable(GL_FOG);
	}
	
	
	
	

	DrawPlants();
	if (wind == true)
	{

	DoTwister();
	}
	if (wind == false)
	{
		//stop wind sound.
		StopWindSound();
	}

	//DoParticles();


	//check time that has passed.
	DWORD time2;
	time2 = GetTickCount();
	
	if (rain == false)
	{
	StopRainSound();
	if ((time2 - time) > 1000)
	{
	
		time = GetTickCount();
		
		if (fogyesno == 1)
		{
		fogendpoint = fogendpoint + incriment;
		}
		blue = blue + 0.01f;
		if (blue > 0.5f)
		{
			
			blue = 0.5f;
			glDisable(GL_FOG);
			fogyesno = 0;
			
		}

		glClearColor( 0.25f, 0.25f, blue, 1.0f );
		float fogcolor[] = { 0.25f, 0.25f, blue, 1.0f};
		
		if (fogyesno == 1)
		{
		glEnable(GL_FOG);
		glFogi(GL_FOG_MODE,GL_LINEAR);
		glFogfv(GL_FOG_COLOR,fogcolor);
		glFogf(GL_FOG_DENSITY,0.35f);
		glHint(GL_FOG_HINT,GL_NICEST);
		glFogf(GL_FOG_START,0.0f);
		glFogf(GL_FOG_END,fogendpoint);
		}
	

	}

	}//end rain==false IF.


	if (rain == true)
	{
		PlayRainSound();
		//bring fog in...
		fogyesno = 1;

		if ((time2 - time) > 1000)
		{
			time = GetTickCount();
			
			fogendpoint = fogendpoint - incriment;
			if (fogendpoint < 501.0f)
			{
				fogendpoint = 501.0f;
			}
			
			blue = blue - 0.01f;
			if (blue < 0.25f)
			{
				blue = 0.25f;
			}

			glClearColor(0.25f,0.25f,blue,1.0f);

		float fogcolor[] = { 0.25f, 0.25f, blue, 1.0f};
		glEnable(GL_FOG);
		glFogi(GL_FOG_MODE,GL_LINEAR);
		glFogfv(GL_FOG_COLOR,fogcolor);
		glFogf(GL_FOG_DENSITY,0.35f);
		glHint(GL_FOG_HINT,GL_NICEST);
		glFogf(GL_FOG_START,0.0f);
		glFogf(GL_FOG_END,fogendpoint);
		


		}

	}

	//end rendering


	



}