/*Particle.cpp----controls particle system things----- I think the fireworks are here, yeah.*/
/* hahah, coding style changes each day */
/*I know I should've used various #include "headerhere.h" but I was putting this together as I went along 
  would've saved time with the typdef struct'ing of NeHe's TextureImage and the repetitive function definitions...*/



/*****************Defines*********************/

#define MAX_PARTICLES 5000
#define RAIN_PARTICLES 2000
#define SEA_LEVEL 25.0f



/*****************Includes********************/
#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>

/******************typedefs*******************/
typedef struct									// Create A Structure
{
	GLubyte	*imageData;							// Image Data (Up To 32 Bits)
	GLuint	bpp;								// Image Color Depth In Bits Per Pixel.
	GLuint	width;								// Image Width
	GLuint	height;								// Image Height
	GLuint	texID;								// Texture ID Used To Select A Texture
} TextureImage;	

TextureImage thetextures[2];
bool LoadTGA(TextureImage *texture, char *filename);	
float GetFrameInterval(void);
void PlayFireworkWhistle(int x);
void StopFireworkWhistle(int x);
void SetFireworkPosition(int number,float x,float y,float z);
void PlayFireworkBoom(int x);
void StopFireworkBoom(int x);
typedef struct _particle
{
	//our particles x,y,and z coordinate.
	float px;
	float py;
	float pz;

	bool alive; //is it living?
	float life; //amount of life left, should be 1.0f to start off with.

	float cred;
	float cgreen;
	float cblue; //red, green, blue color things.

	float time; //amount of time that particle "lives", actually just a # between 0.001 and 0.1, every round gets subtracted from float life

	float vx;
	float vy;
	float vz; //velocity of x,y, and z.

	float nvx;
	float nvy;
	float nvz; //negitive amounts.


	float ygravity; //y's gravity. 

	float size; //width/height of particle.

	float velocitydecrease; //slow down particles.
}particle,*ptr_particle;

typedef struct _firework
{
	float x,y,z; //whole fireworks position.
	float vx,vy,vz; //velocity of entire particle system.
	particle fireworkparticles[MAX_PARTICLES];
	int timebeforeboom;
	int lengthofstay;

	int timebeforeboominseconds;
	int lengthofstayinseconds;
	int currenttime;
	int currenttimeboom;

}firework,*ptr_firework;



/******************varibles******************/

//particle particles[MAX_PARTICLES];
particle raindrops[RAIN_PARTICLES];
firework redfirework[5];

void SetUpParticles(ptr_particle particles,float size,float red,float green, float blue);
void DoParticles(ptr_particle particles);
float GetAngleturn(void);
float GetAngleUp(void);

/******************functions*****************/


void DrawFireworks(void)
{
	
	int counter;
	for (counter = 0; counter < 5; counter++)
	{

	glPushMatrix();
	glTranslatef(redfirework[counter].x,redfirework[counter].y,redfirework[counter].z);
	glRotatef(GetAngleturn(),0,1,0);
	glRotatef(GetAngleUp(),1,0,0);


	
	if (  (timeGetTime() - redfirework[counter].currenttime)  < redfirework[counter].timebeforeboominseconds )
	{
	SetFireworkPosition(counter,redfirework[counter].x,redfirework[counter].y,redfirework[counter].z);
	PlayFireworkWhistle(counter);
	redfirework[counter].x = redfirework[counter].x + redfirework[counter].vx * GetFrameInterval() * 25;
	redfirework[counter].y = redfirework[counter].y + redfirework[counter].vy * GetFrameInterval() * 25;
	redfirework[counter].z = redfirework[counter].z + redfirework[counter].vz * GetFrameInterval() * 25;
	auxSolidSphere(0.5f);
	redfirework[counter].currenttimeboom = timeGetTime();
	}
	

	if ( (timeGetTime() - redfirework[counter].currenttime) > redfirework[counter].timebeforeboominseconds )
	{
			//BOOM time,whistle sound can stop, Pop sound can play. once..
			StopFireworkWhistle(counter);
			
			if ( (timeGetTime() - redfirework[counter].currenttimeboom) < redfirework[counter].lengthofstayinseconds)
			{
				//PLAY EXPLOSION SOUND HERE ONCE.
				
				PlayFireworkBoom(counter);
				
				DoParticles(redfirework[counter].fireworkparticles);
			}
			
			if ( (timeGetTime() - redfirework[counter].currenttimeboom) > redfirework[counter].lengthofstayinseconds)
			{
				StopFireworkBoom(counter);
				redfirework[counter].lengthofstayinseconds = 700;
				redfirework[counter].timebeforeboominseconds = rand()%6000 + 2000;
				redfirework[counter].x = rand()%1000;
				redfirework[counter].y = rand()%100;
				redfirework[counter].z = -800.0f;
				redfirework[counter].vx = 0;
				redfirework[counter].vy = 3.0f;
				redfirework[counter].vz = 0;
				redfirework[counter].currenttime = timeGetTime();
			}

			
	}


	

	glPopMatrix();
	}//end big for loop.
}

void SetupFireworks(void)
{
	int counter;
	for (counter = 0; counter < 5; counter++)
	{

	redfirework[counter].x = rand()%1000;
	redfirework[counter].y = rand()%100;
	redfirework[counter].z = -800.0f;
	redfirework[counter].vx = 0;
	redfirework[counter].vy = 3.0f;
	redfirework[counter].vz = 0;
	redfirework[counter].timebeforeboom = rand()%300;
	redfirework[counter].lengthofstay = 100;
	
	/******NEW******/
	redfirework[counter].currenttime = timeGetTime();
	redfirework[counter].timebeforeboominseconds = rand()%6000 + 2000; //miliseconds.
	redfirework[counter].lengthofstayinseconds = 700;
	/******End New ******/


	SetUpParticles(redfirework[counter].fireworkparticles,0.5f, float((rand()%10 + 1)) / 10   ,float((rand()%10 + 1)) / 10,   float((rand()%10 + 1)) / 10);
	}

LoadTGA(&thetextures[0],"boom.tga");

}

void SetUpParticles(ptr_particle particles,float size,float red,float green, float blue)
{
	//set up our particle system.
	int counting;
	for (counting = 0; counting < MAX_PARTICLES; counting++)
	{
		particles[counting].alive = true; //should be alive to start out with..
		particles[counting].life = 1.0f; //life shoudl always be 1.0f
		particles[counting].px = 0.0f; //set the starting position at 0,0,0
		particles[counting].py = 0.0f;//" "
		particles[counting].pz = 0.0f;//" "
		particles[counting].cblue = blue;//float((rand()%10 + 1)) / 10; //make a random blue color from 0.1 to 1.0f.
		particles[counting].cgreen = green;//float((rand()%10 + 1)) / 10; // " "
		particles[counting].cred = red;// float((rand()%10 + 1)) / 10; // " "
		particles[counting].time = 0.05f;//float((rand()%10 + 1)) / 100; //was 10000//sets our life somewhere between 0.001 and 0.01f
		//particles[counting].vx = 0.001f; //amount moving right.
		//particles[counting].vy = -0.005f; //moving up
		particles[counting].vx = float(rand()%10 + 1) / 1.0f;
		particles[counting].vy = float(rand()%10 + 1) / 1.0f;
		particles[counting].vz = float(rand()%10 + 1) / 1.0f; 

		particles[counting].nvx = - (float(rand()%10 + 1) / 1.0f);
		particles[counting].nvy = - (float(rand()%10 + 1) / 1.0f);
		particles[counting].nvz = - (float(rand()%10 + 1) / 1.0f);

		particles[counting].ygravity = -0.05f; //our constant gravity.

		particles[counting].velocitydecrease = 1.0f;
		//set the width/height.
		particles[counting].size = 2.0f;//2.0f;//size;
	
	}

} //end SetUpParticles()


void DoParticles(ptr_particle particles)
{
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glEnable(GL_TEXTURE_2D);

	glBindTexture(GL_TEXTURE_2D,thetextures[0].texID);
	int counting;
	for (counting = 0; counting < MAX_PARTICLES; counting++)
	{
		if (particles[counting].alive == true)
		{//is the particle alive? if not, wouldn't do anything.
			//set the color to the particles color.
			glColor4f(particles[counting].cred,particles[counting].cgreen,particles[counting].cblue,particles[counting].life);
			//note to self turn on alpha bending before this with ALPHA_SRC_MINUS_ONE thing.
			

			//render the scene now..
			glBegin(GL_QUADS);
				//render it using a quad, yes...I know. quads may not be accelerated all the time.
				//we use the size /2 because if hte particle is 1, then we want to move half of one,
				//, 0.5f, in each direction out from the center.
			//bottom left.
			glTexCoord2f(0.0f,0.0f);
			glVertex3f(particles[counting].px - (particles[counting].size/2) ,particles[counting].py - (particles[counting].size/2)  ,particles[counting].pz   );
			
			//bottom right..
			glTexCoord2f(1.0f,0.0f);
			glVertex3f(particles[counting].px + (particles[counting].size/2), particles[counting].py - (particles[counting].size/2), particles[counting].pz   );

			//top right.
			glTexCoord2f(1.0f,1.0f);
			glVertex3f(particles[counting].px + (particles[counting].size/2),particles[counting].py + (particles[counting].size/2), particles[counting].pz   );

			//top left.
			glTexCoord2f(0.0f,1.0f);
			glVertex3f(particles[counting].px - (particles[counting].size/2), particles[counting].py + (particles[counting].size/2), particles[counting].pz  );

			


			//stop rendering.
			glEnd();

			
			//shorten the life of our particle.
			particles[counting].life = particles[counting].life - particles[counting].time * GetFrameInterval() * 30;
			
			//move our particles.
			particles[counting].px = particles[counting].px + particles[counting].vx * GetFrameInterval() * 20;
			particles[counting].py = particles[counting].py + particles[counting].vy * GetFrameInterval() * 20;
			particles[counting].pz = particles[counting].pz + particles[counting].vz * GetFrameInterval() * 20; 
			particles[counting].px = particles[counting].px + particles[counting].nvx * GetFrameInterval() * 20;;
			particles[counting].py = particles[counting].py + particles[counting].nvy * GetFrameInterval() * 20;;
			particles[counting].pz = particles[counting].pz + particles[counting].nvz * GetFrameInterval() * 20; 
			
			particles[counting].vx = particles[counting].vx - particles[counting].velocitydecrease * GetFrameInterval() * 20;
			particles[counting].vy = particles[counting].vy - particles[counting].velocitydecrease * GetFrameInterval() * 20;
			particles[counting].vz = particles[counting].vz - particles[counting].velocitydecrease * GetFrameInterval() * 20;
			particles[counting].nvx = particles[counting].nvx + particles[counting].velocitydecrease * GetFrameInterval() * 20;
			particles[counting].nvy = particles[counting].nvy + particles[counting].velocitydecrease * GetFrameInterval() * 20;
			particles[counting].nvz = particles[counting].nvz + particles[counting].velocitydecrease * GetFrameInterval() * 20;
			//now to add in gravity.
			particles[counting].vy = particles[counting].vy + particles[counting].ygravity * GetFrameInterval() * 20;

			if (particles[counting].life < 0.0f) //eh oh restart the particle system.
			{
				particles[counting].life = 1.0f; //give it new life.
				
				//reset its location..note to self add more stuff here after particle system actuallyworks.
				particles[counting].px = 0.0f;
				particles[counting].py = 0.0f;
				particles[counting].pz = 0.0f;
				
				//time to reset the velocities.
		particles[counting].vx = float(rand()%10 + 1) / 1.0f; //was 1000.
		particles[counting].vy = float(rand()%10 + 1) / 1.0f; //this already was 100.
		particles[counting].vz = float(rand()%10 + 1) / 1.0f; 

		particles[counting].nvx = -(float(rand()%10 + 1) / 1.0f);
		particles[counting].nvy = -(float(rand()%15 + 1) / 1.0f);
		particles[counting].nvz = -(float(rand()%10 + 1) / 1.0f);

				particles[counting].time = 0.05f;//float((rand()%10 + 1)) / 100; //set it to some new time.
				//0.05f
				//reset the colorss
				//particles[counting].cblue = 0.0f;//float((rand()%10 + 1)) / 10; //make a random blue color from 0.1 to 1.0f.
				//particles[counting].cgreen = 0.0f;//float((rand()%10 + 1)) / 10; // " "
				//particles[counting].cred = float((rand()%10 + 1)) / 10; // " "
			
			}


			


			
		
		
		}

	
	} //end particle system..
	glDisable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);
}//end DoParticle()



void SetupRain(void)
{
	//I don't feel like scrolling down to initGl() and making that more bloated so I'll just put it here.
	//the *.life varible is just anothe rcolor in this instance, and the particle "dies" when it hits the ground.
	int counting; //our counting varible..

	for (counting = 0; counting < RAIN_PARTICLES; counting++)
	{
		//start up the initilizing loop..
		float range = 32 * 160 + 4000.0f;

		raindrops[counting].alive = true;  //yup, its alive..
		raindrops[counting].cblue = 1.0f; //I want white....to start off with...maybe I"ll make it more blue then white..
		raindrops[counting].cgreen = 0.5f;  // " "
		raindrops[counting].cred = 0.5f;  // " "
		raindrops[counting].life = 1.0f; //maybe not use this.....make all drops same transparency? hmmm..no...random ##. 
		raindrops[counting].nvx = 0.0f; //wind factor.
		raindrops[counting].nvy = NULL;
		raindrops[counting].nvz = NULL;
		raindrops[counting].px = (rand()%int(range) - 2000.0f); //yeah, its over complexed.  
		raindrops[counting].py = rand()%5000;  //always start at sky level. .duh.
		raindrops[counting].pz = (-(rand()%int(range)) + 2000.0f); 
		raindrops[counting].size = NULL;
		raindrops[counting].time = NULL;
		raindrops[counting].vy = -70.0f;//(-rand()%20 - 10); //make this random too.



	}

}

void DoRain(void)
{
	//again, horribly laazy.
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	int counting;
	glDisable(GL_TEXTURE_2D);
	for (counting = 0; counting < RAIN_PARTICLES; counting++)
	{
		glColor4f(raindrops[counting].cred,raindrops[counting].cgreen,raindrops[counting].cblue,0.5f);
		
		
		//our raindrop is just a Line. shhhh. 
		
		
		glBegin(GL_LINES);

		glVertex3f(raindrops[counting].px,raindrops[counting].py,raindrops[counting].pz);
		glVertex3f(raindrops[counting].px,raindrops[counting].py - 16.0f,raindrops[counting].pz);
		

		
		glEnd(); 
		
		
		float range = 32 * 160 + 4000.0f;
		raindrops[counting].py =  raindrops[counting].py + raindrops[counting].vy * GetFrameInterval() * 20;
		raindrops[counting].px = raindrops[counting].px + raindrops[counting].nvx * GetFrameInterval() * 20;
		if (raindrops[counting].py < SEA_LEVEL)
		{
			//rain should explode or something neat here.
			raindrops[counting].py = 5000.0f;
			raindrops[counting].px = rand()%int(range) - 2000.0f;
		
		}

	}
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
}