/*Terrain File: GetHeight() midified from Opengl Game Programming*/
#define MAPX 32
#define MAPZ 32
#define SCALEFACTOR 160


#include <windows.h>
#include <gl/gl.h> 
#include <gl/glu.h>
#include <gl/glaux.h> 
#include <math.h> 
#include <stdio.h>
#include <stdlib.h>


//varible defines
float	terrain[MAPX][MAPZ][3];
AUX_RGBImageRec *heightmap = NULL;


unsigned int terraintexture;

void InitTerrain(void) 
{
	//sets up terrain and all that sorta stuff.  

	
	FILE *map = NULL;
	
	map = fopen("heightmap.bmp","rb");
	heightmap = auxDIBImageLoad("heightmap.bmp");


	FILE *file = NULL;;
	AUX_RGBImageRec *bitmap3 = NULL;
	
	file = fopen("image1.bmp","br");
	bitmap3 = auxDIBImageLoad("image1.bmp");


	glGenTextures(1,&terraintexture);
	glBindTexture(GL_TEXTURE_2D,terraintexture);
	glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	
	
	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB,256,256,GL_RGB,GL_UNSIGNED_BYTE,bitmap3->data);
	
	
	
	int x,z; //counting variables.
	for (z = 0; z < MAPZ; z++)
	{
		for (x = 0; x < MAPX; x++)
		{
			terrain[x][z][0] = float(x) * SCALEFACTOR; // 0 = X.
			terrain[x][z][1] = (float)heightmap->data[(z * MAPZ + x) * 3];
			terrain[x][z][2] = -(float(z) * SCALEFACTOR); //2 = z; x,y,z, 0,1,2. 
			 //2 = z; x,y,z, 0,1,2.
		}

	}
	



} //end Initterrain()


float GetHeight(float x, float z)
{	
		float projCameraX, projCameraZ;
		projCameraX = x / SCALEFACTOR;
		projCameraZ = -z / SCALEFACTOR;  
		int col0 = int(projCameraX);
		int row0 = int(projCameraZ);
		int col1 = col0 + 1;
		int row1 = row0 + 1;
		
		// make sure that the cell coordinates don't fall
		// outside the height field.
		if (col1 > MAPX)
			col1 = 0;
		if (row1 > MAPZ)
			row1 = 0;

		// get the four corner heights of the cell from the height field
		float h00 = (float)terrain[col0][row0][1];//(float)heightMap[col0 + row0*width];
		float h01 = (float)terrain[col1][row0][1];//(float)heightMap[col1 + row0*width];
		float h11 = (float)terrain[col1][row1][1];//(float)heightMap[col1 + row1*width];
		float h10 = (float)terrain[col0][row1][1];//(float)heightMap[col0 + row1*width];

		// calculate the position of the camera relative to the cell.
		// note, that 0 <= tx, ty <= 1.
		float tx = projCameraX - float(col0);
		float ty = projCameraZ - float(row0);

		// the next step is to perform a bilinear interpolation
		// to compute the height of the terrain directly below
		// the object.
		float txty = tx * ty;

		float final_height = h00 * (1.0f - ty - tx + txty)
						+ h01 * (tx - txty)
						+ h11 * txty
						+ h10 * (ty - txty);

		return final_height;
}

void DrawTerrain(void)
{
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,terraintexture);
	int x,z; //counting varibles for terrain.
	for (z = 0; z < MAPZ - 1; z++)
	{
		glBegin(GL_TRIANGLE_STRIP);
		for (x = 0; x < MAPX - 1; x++)
		{
			
			//glTexCoord2f(0.0f,1.0f);
			glTexCoord2f(float(x) / float(MAPX),float(z)/float(MAPZ));
			glColor4f(terrain[x][z][1]/255.0f,terrain[x][z][1]/255.0f,terrain[x][z][1]/255.0f,1.0f);
			glVertex3f(terrain[x][z][0],terrain[x][z][1],terrain[x][z][2]);

			
			//glTexCoord2f(1.0f,1.0f);
			glTexCoord2f(float(x+1) / float(MAPX),float(z)/float(MAPZ));
			glColor4f(terrain[x+1][z][1]/255.0f,terrain[x+1][z][1]/255.0f,terrain[x+1][z][1]/255.0f,1.0f);
			glVertex3f(terrain[x+1][z][0],terrain[x+1][z][1],terrain[x+1][z][2]);

	

			//glTexCoord2f(0.0f,0.0f);
			glTexCoord2f(float(x)/float(MAPX),float(z+1)/float(MAPZ));
			glColor4f(terrain[x][z+1][1]/255.0f,terrain[x][z+1][1]/255.0f,terrain[x][z+1][1]/255.0f,1.0f);
			glVertex3f(terrain[x][z+1][0],terrain[x][z+1][1],terrain[x][z+1][2]);
			
			
			//glTexCoord2f(1.0f,0.0f);
			glTexCoord2f(float(x+1)/float(MAPX),float(z+1)/float(MAPZ));
			glColor4f(terrain[x+1][z+1][1]/255.0f,terrain[x+1][z+1][1]/255.0f,terrain[x+1][z+1][1]/255.0f,1.0f);
			glVertex3f(terrain[x+1][z+1][0],terrain[x+1][z+1][1],terrain[x+1][z+1][2]);

			
		}
		glEnd();

	}
}
