#define MAPX 32
#define MAPZ 32
#define SCALEFACTOR	160.0f
#define SEA_LEVEL 25.0f


#include <windows.h>
#include <stdio.h>
#include <gl/gl.h> 
#include <gl/glu.h> 
#include <gl/glaux.h> 
#include <math.h> 


unsigned int waternumber;


float GetFrameInterval(void);
float angle = 0;
float sinangle = 0;

void WaterSetup(void)
{

	
	
	glGenTextures(1,&waternumber);
	glBindTexture(GL_TEXTURE_2D,waternumber);
	
	FILE *file;
	AUX_RGBImageRec *waterimage = NULL;
	file = fopen("water.bmp","rb");
	waterimage = auxDIBImageLoad("water.bmp");
	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB,256,256,GL_RGB,GL_UNSIGNED_BYTE,waterimage->data);
	
}


void DrawWater(void)
{
	glBindTexture(GL_TEXTURE_2D,waternumber);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glMatrixMode(GL_TEXTURE);
	
	glRotatef(angle,0.0f,0.0f,1.0f);
	angle = angle + (5.1f * GetFrameInterval() );
	sinangle = sinangle + 0.01f * GetFrameInterval();
	glMatrixMode(GL_MODELVIEW);
	glBegin(GL_QUADS);
		//render water..

		//the bottom left is at about 0.0.0, then we use the map scale and what not to calculate where the water would be, then ad 50 on to it so it continues out .
		//bottom left.
		glColor4f(0.4f,0.4f,1.0f,0.5f);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f(-5000.0f,SEA_LEVEL + (sinf(sinangle * 20) * 2),5000.0f); //x was 0, z was -5.
		
		//top left..
		glTexCoord2f(0.0f,1.0f);
		glVertex3f(-5000.0f,SEA_LEVEL + (sinf(sinangle * 20) * 2),-(MAPZ * SCALEFACTOR) - 5000.0f);

		//top right..
		glTexCoord2f(1.0f,1.0f);
		glVertex3f((MAPX * SCALEFACTOR) + 5000.0f,SEA_LEVEL + (sinf(sinangle * 20) * 2 ),-(MAPZ * SCALEFACTOR) -5000.0f);


		//bottom right..
		glTexCoord2f(1.0f,0.0f);
		glVertex3f((MAPX * SCALEFACTOR) + 5000.0f,SEA_LEVEL + (sinf(sinangle * 20) * 2),5000.0f); //x was MAPX * MAP_SCALE, z was -5.


	glEnd(); 
	glDisable(GL_BLEND);
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
}